package net.minecraftforge.items.wrapper;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.item.ItemStack;

public class PlayerArmorInvWrapper extends InvWrapper
{
    public final InventoryPlayer inventoryPlayer;
    public final int offset;

    public PlayerArmorInvWrapper(InventoryPlayer inv)
    {
        super(inv);

        inventoryPlayer = inv;
        offset = inventoryPlayer.field_70462_a.length;
    }

    @Override
    public int getSlots()
    {
        return inventoryPlayer.field_70460_b.length;
    }

    @Override
    public ItemStack getStackInSlot(int slot)
    {
        return super.getStackInSlot(slot + offset);
    }

    @Override
    public ItemStack insertItem(int slot, ItemStack stack, boolean simulate)
    {
        EntityEquipmentSlot equ = null;
        for (EntityEquipmentSlot s : EntityEquipmentSlot.values())
        {
            if (s.func_188453_a() == EntityEquipmentSlot.Type.ARMOR && s.func_188454_b() == slot)
            {
                equ = s;
                break;
            }
        }
        // check if it's valid for the armor slot
        if (slot < 4 && stack != null && stack.func_77973_b().isValidArmor(stack, equ, inventoryPlayer.field_70458_d))
        {
            return super.insertItem(slot + offset, stack, simulate);
        }
        return stack;
    }

    @Override
    public void setStackInSlot(int slot, ItemStack stack)
    {
        super.setStackInSlot(slot + offset, stack);
    }

    @Override
    public ItemStack extractItem(int slot, int amount, boolean simulate)
    {
        return super.extractItem(slot + offset, amount, simulate);
    }
}
